import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React from 'react';
import { createListDataProvider } from '@billogram/foundation-list-data-provider';
import createTable from './createTable';
export default function createTableProvider() {
  var _createListDataProvid = createListDataProvider(),
      FoundationListDataConsumer = _createListDataProvid.FoundationListDataConsumer,
      FoundationListDataProvider = _createListDataProvid.FoundationListDataProvider;

  var _createTable = createTable(),
      FoundationTable = _createTable.FoundationTable,
      FoundationTableRowConsumer = _createTable.FoundationTableRowConsumer,
      FoundationTableRowContext = _createTable.FoundationTableRowContext,
      useTableRow = _createTable.useTableRow;

  function FoundationTableDataProvider(_ref) {
    var _ref$children = _ref.children,
        children = _ref$children === void 0 ? null : _ref$children,
        fetchData = _ref.fetchData,
        initialFetchDataOptions = _ref.initialFetchDataOptions,
        initialLimit = _ref.initialLimit,
        initialSortBy = _ref.initialSortBy,
        initialSortDirection = _ref.initialSortDirection;
    return /*#__PURE__*/React.createElement(FoundationListDataProvider, {
      fetchData: fetchData,
      initialFetchDataOptions: initialFetchDataOptions,
      initialLimit: initialLimit,
      initialSortBy: initialSortBy,
      initialSortDirection: initialSortDirection
    }, children);
  }

  function FoundationTableDataConsumer(_ref2) {
    var additionalRowData = _ref2.additionalRowData,
        columns = _ref2.columns,
        EmptyState = _ref2.EmptyState,
        isSearchResult = _ref2.isSearchResult,
        searchFields = _ref2.searchFields,
        searchTerms = _ref2.searchTerms,
        subTitle = _ref2.subTitle,
        tableName = _ref2.tableName,
        TableRow = _ref2.TableRow,
        TableRowExpand = _ref2.TableRowExpand,
        title = _ref2.title,
        titleFilter = _ref2.titleFilter;
    return /*#__PURE__*/React.createElement(FoundationListDataConsumer, null, function (_ref3) {
      var fetchInitial = _ref3.fetchInitial,
          fetchMore = _ref3.fetchMore,
          fetchSort = _ref3.fetchSort,
          removeItem = _ref3.removeItem,
          result = _ref3.result,
          updateItem = _ref3.updateItem;
      return /*#__PURE__*/React.createElement(FoundationTable, {
        additionalRowData: additionalRowData,
        columns: columns,
        EmptyState: EmptyState,
        fetchInitial: fetchInitial,
        fetchMore: fetchMore,
        fetchSort: fetchSort,
        isSearchResult: isSearchResult,
        removeItem: removeItem,
        searchFields: searchFields,
        searchTerms: searchTerms,
        subTitle: subTitle,
        table: result,
        tableName: tableName,
        TableRow: TableRow,
        TableRowExpand: TableRowExpand,
        title: title,
        titleFilter: titleFilter,
        updateItem: updateItem
      });
    });
  }

  function FoundationTableDataProsumer(props) {
    var fetchData = props.fetchData,
        initialFetchDataOptions = props.initialFetchDataOptions,
        initialLimit = props.initialLimit,
        initialSortBy = props.initialSortBy,
        initialSortDirection = props.initialSortDirection,
        consumerProps = _objectWithoutProperties(props, ["fetchData", "initialFetchDataOptions", "initialLimit", "initialSortBy", "initialSortDirection"]);

    return /*#__PURE__*/React.createElement(FoundationTableDataProvider, {
      fetchData: fetchData,
      initialFetchDataOptions: initialFetchDataOptions,
      initialLimit: initialLimit,
      initialSortBy: initialSortBy,
      initialSortDirection: initialSortDirection
    }, /*#__PURE__*/React.createElement(FoundationTableDataConsumer, consumerProps));
  }

  return {
    FoundationTableDataConsumer: FoundationTableDataConsumer,
    FoundationTableDataProsumer: FoundationTableDataProsumer,
    FoundationTableDataProvider: FoundationTableDataProvider,
    FoundationTableRowConsumer: FoundationTableRowConsumer,
    FoundationTableRowContext: FoundationTableRowContext,
    useTableRow: useTableRow
  };
}
//# sourceMappingURL=createTableProvider.js.map