import React from 'react';
import purebem from 'purebem';
import { pgettext } from '@billogram/lang';
import { FoundationThreeBounceSpinner } from '@billogram/foundation-spinner';
import { useTableRowInternal } from '../row/FoundationTableRowContextInternal';
import './FoundationTableRowExpandResultGroup.scss';
export default function FoundationTableRowExpandResultGroup(_ref) {
  var children = _ref.children,
      _ref$errorMessage = _ref.errorMessage,
      errorMessage = _ref$errorMessage === void 0 ? null : _ref$errorMessage,
      _ref$hasFetchError = _ref.hasFetchError,
      hasFetchError = _ref$hasFetchError === void 0 ? false : _ref$hasFetchError,
      _ref$isFetching = _ref.isFetching,
      isFetching = _ref$isFetching === void 0 ? false : _ref$isFetching;
  var block = purebem('foundation-table-row-expand-result-group');

  function renderError() {
    return errorMessage !== null ? errorMessage : /*#__PURE__*/React.createElement("div", null, pgettext('foundation-table-row-expand-result', 'Error'));
  }

  function renderSpinner() {
    return /*#__PURE__*/React.createElement("div", {
      className: block('spinner')
    }, /*#__PURE__*/React.createElement(FoundationThreeBounceSpinner, null));
  }

  var _useTableRowInternal = useTableRowInternal(),
      handle = _useTableRowInternal.handle,
      highlight = _useTableRowInternal.highlight;

  return /*#__PURE__*/React.createElement("article", {
    className: block({
      error: hasFetchError,
      handled: handle.value,
      highlighted: highlight.value
    })
  }, isFetching ? renderSpinner() : hasFetchError ? renderError() : children);
}
//# sourceMappingURL=FoundationTableRowExpandResultGroup.js.map