import React from 'react';
import purebem from 'purebem';
import './FoundationTableHeaderCell.scss';
export default function FoundationTableHeaderCell(_ref) {
  var currentSortBy = _ref.currentSortBy,
      currentSortDirection = _ref.currentSortDirection,
      _ref$children = _ref.children,
      children = _ref$children === void 0 ? /*#__PURE__*/React.createElement("span", null, "\xA0") : _ref$children,
      columnName = _ref.columnName,
      _ref$hidden = _ref.hidden,
      hidden = _ref$hidden === void 0 ? false : _ref$hidden,
      isFetching = _ref.isFetching,
      shouldDisableSorting = _ref.shouldDisableSorting,
      sort = _ref.sort,
      _ref$sortByColumnKey = _ref.sortByColumnKey,
      sortByColumnKey = _ref$sortByColumnKey === void 0 ? '' : _ref$sortByColumnKey;
  var block = purebem('foundation-table-header-cell');
  var canSort = !shouldDisableSorting && typeof sortByColumnKey === 'string' && sortByColumnKey !== '';
  var sortedBy = currentSortBy === sortByColumnKey;
  var sortDirection = sortedBy ? "sorted-by-".concat(currentSortDirection) : false;
  var handleSort = React.useCallback(function () {
    sort(sortByColumnKey);
  }, [sort, sortByColumnKey]);
  return /*#__PURE__*/React.createElement("th", {
    className: block({
      hidden: hidden,
      isFetching: isFetching
    }),
    "data-table-column-name": columnName
  }, canSort ? /*#__PURE__*/React.createElement("button", {
    className: block('sort-button', {
      canSort: canSort,
      sortedBy: sortedBy,
      sortDirection: sortDirection
    }),
    onClick: handleSort
  }, children) : children);
}
//# sourceMappingURL=FoundationTableHeaderCell.js.map