import React from 'react';
import purebem from 'purebem';
import { useTableRowInternal } from './FoundationTableRowContextInternal';
import './FoundationTableCell.scss';
export default function FoundationTableCell(_ref) {
  var _ref$canExpand = _ref.canExpand,
      canExpand = _ref$canExpand === void 0 ? false : _ref$canExpand,
      children = _ref.children,
      columnName = _ref.columnName;
  var block = purebem('foundation-table-cell');

  var _useTableRowInternal = useTableRowInternal(),
      expand = _useTableRowInternal.expand;

  return /*#__PURE__*/React.createElement("td", {
    className: block({
      canExpand: canExpand
    }),
    "data-table-column-name": columnName
  }, canExpand ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("button", {
    className: block('content', ['can-expand-value-button']),
    onClick: expand.toggle,
    tabIndex: -1
  }, children), /*#__PURE__*/React.createElement("div", {
    className: block('content', ['can-expand-value'])
  }, children)) : children);
}
//# sourceMappingURL=FoundationTableCell.js.map