import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React from 'react';
import purebem from 'purebem';
import useToggle from '@billogram/use-toggle';
import FoundationTableRowSearchResultGroup from '../search-result-group/FoundationTableRowSearchResultGroup';
import { FoundationTableRowContextInternalProvider } from './FoundationTableRowContextInternal';
import useExpandToggle from './useExpandToggle';
import './createTableRowProvider.scss';

function noop() {}

var toggler = {
  set: noop,
  toggle: noop,
  unset: noop,
  value: false
};
export var block = purebem('foundation-table-row-provider');
export default function createTableRowProvider() {
  var FoundationTableRowContext = /*#__PURE__*/React.createContext({
    columns: [],
    expand: {
      action: '',
      set: noop,
      setWith: noop,
      toggle: noop,
      toggleWith: noop,
      unset: noop,
      value: false
    },
    handle: toggler,
    highlight: toggler,
    refetchTable: function () {
      var _refetchTable = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function refetchTable() {
        return _refetchTable.apply(this, arguments);
      }

      return refetchTable;
    }(),
    remove: noop,
    transparency: toggler,
    update: noop
  });

  function FoundationTableRowProvider(_ref) {
    var _ref$additionalData = _ref.additionalData,
        additionalData = _ref$additionalData === void 0 ? {} : _ref$additionalData,
        columns = _ref.columns,
        fetchInitial = _ref.fetchInitial,
        isFetching = _ref.isFetching,
        isLast = _ref.isLast,
        isOdd = _ref.isOdd,
        isSearchResult = _ref.isSearchResult,
        item = _ref.item,
        removeItem = _ref.removeItem,
        _ref$searchFields = _ref.searchFields,
        searchFields = _ref$searchFields === void 0 ? [] : _ref$searchFields,
        searchTerms = _ref.searchTerms,
        TableRow = _ref.TableRow,
        TableRowExpand = _ref.TableRowExpand,
        updateItem = _ref.updateItem;
    var expand = useExpandToggle();
    var handle = useToggle();
    var highlight = useToggle();
    var transparency = useToggle();
    var remove = React.useCallback(function () {
      removeItem(item);
    }, [item, removeItem]);
    var update = React.useCallback(function (data) {
      updateItem(_objectSpread(_objectSpread({}, item), {}, {
        data: data
      }));
    }, [item, updateItem]);
    var context = React.useMemo(function () {
      return {
        columns: columns,
        expand: expand,
        handle: handle,
        highlight: highlight,
        refetchTable: fetchInitial,
        transparency: transparency,
        remove: remove,
        update: update
      };
    }, [columns, expand, fetchInitial, handle, highlight, remove, transparency, update]);
    var _even$expanded$fetchi = {
      even: !isOdd && !isSearchResult,
      expanded: expand.value,
      fetching: isFetching,
      handled: handle.value,
      highlighted: highlight.value,
      last: isLast && !isSearchResult,
      odd: isOdd && !isSearchResult,
      search: isSearchResult,
      transparent: transparency.value
    },
        even = _even$expanded$fetchi.even,
        expanded = _even$expanded$fetchi.expanded,
        fetching = _even$expanded$fetchi.fetching,
        handled = _even$expanded$fetchi.handled,
        highlighted = _even$expanded$fetchi.highlighted,
        last = _even$expanded$fetchi.last,
        odd = _even$expanded$fetchi.odd,
        search = _even$expanded$fetchi.search,
        transparent = _even$expanded$fetchi.transparent;
    return /*#__PURE__*/React.createElement(FoundationTableRowContextInternalProvider, {
      columns: columns,
      expand: expand,
      handle: handle,
      highlight: highlight,
      transparency: transparency
    }, /*#__PURE__*/React.createElement(FoundationTableRowContext.Provider, {
      value: context
    }, /*#__PURE__*/React.createElement("tbody", {
      className: block({
        even: even,
        expanded: expanded,
        fetching: fetching,
        handled: handled,
        highlighted: highlighted,
        last: last,
        odd: odd,
        search: search,
        transparent: transparent
      })
    }, /*#__PURE__*/React.createElement(TableRow, {
      additionalData: additionalData,
      data: item.data
    }), expand.value && TableRowExpand !== void 0 ? /*#__PURE__*/React.createElement(TableRowExpand, {
      additionalData: additionalData,
      data: item.data
    }) : null, isSearchResult ? /*#__PURE__*/React.createElement(FoundationTableRowSearchResultGroup, {
      data: item.data,
      fields: searchFields,
      terms: searchTerms
    }) : null)));
  }

  function FoundationTableRowConsumer(_ref2) {
    var children = _ref2.children;
    return /*#__PURE__*/React.createElement(FoundationTableRowContext.Consumer, null, function (context) {
      return children(context);
    });
  }

  function useTableRow() {
    return React.useContext(FoundationTableRowContext);
  }

  return {
    FoundationTableRowProvider: FoundationTableRowProvider,
    FoundationTableRowConsumer: FoundationTableRowConsumer,
    FoundationTableRowContext: FoundationTableRowContext,
    useTableRow: useTableRow
  };
}
//# sourceMappingURL=createTableRowProvider.js.map