import getRanges from './getRanges';

import type {
    HighlightRange,
} from './types';


test('no matches', () => {
    const result = getRanges('cupcake ipsum dolor sit amet', ['xxx']);
    expect(result).toEqual([]);
});

test.each<[string, HighlightRange[]]>([
    ['cupcake', [[0, 7]]],
    ['ipsum', [[8, 13]]],
    ['dolor', [[14, 19]]],
    ['sit', [[20, 23]]],
    ['amet', [[24, 28]]],
])('single match %s', (matchingTerm: string, ranges: HighlightRange[]) => {
    const result = getRanges('cupcake ipsum dolor sit amet', [matchingTerm]);
    expect(result).toEqual(ranges);
});

test('multiple matches', () => {
    const result = getRanges('cupcake ipsum dolor sit amet', ['c']);
    expect(result).toEqual([
        [0, 1],
        [3, 4],
    ]);
});
